// FCriminal.cpp: implementation of the FCriminal class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FCriminal.h"
#include "Prison.h"
#include "LSYSLIB\FDelayCLK.h"
#include <lsyslib\lsyslib.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FCriminal::FCriminal():LFsaAppl() { }

FCriminal::FCriminal(int n, TNetFsa *pNetFsa, CPrison *pPr, LArc *pTBL)
	:LFsaAppl(pTBL)
{
	bGoToPunishmentCell = false;	//	   
	nQuantityOfVisitings = 0;		//	  
	pCPrison = pPr;
	nNumber = n;					//	  ()
	bSavLamp = false;				//	  
	nSavAcntLamp = 0;				//	    
	bYes=false;

	if (pNetFsa) FLoad(pNetFsa,1);	
}

FCriminal::~FCriminal() { }

bool FCriminal::operator==(const FCriminal &var) const	
{ 
	if (nNumber==var.nNumber) return true;
	else return false;
}

int FCriminal::GetNumber() { return nNumber; }

void FCriminal::SetNumber(int n) { nNumber = n;	}

//
LArc TT_Criminal[] = {
/*
	LArc("_",	"_k",	"x1",	"y1"),	//	 
	LArc("_k",	"_",	"--", 	"y2"),
*/
//	       
//*
	LArc("",	"p",	"x1",		"y1"),	//	 
	LArc("p",	"",	"^x6", 		"y2"),
	LArc("p",	"",	"^x4x5x6", 	"y4"),
	LArc("p",	"",	"^x5x6", 	"y3"),
	LArc("p",	"yes",	"x4x5x6", 	"--"),
	LArc("yes",	"",	"--",	 	"--"),
//*/
//	    
/*
	LArc("",	"p",	"x1",		"y1"),	//	 
	LArc("p",	"",	"^x6", 		"y2y5"),
	LArc("p",	"",	"^x4x5x6", 	"y4y5"),
	LArc("p",	"",	"^x5x6", 	"y3y5"),
	LArc("p",	"yes",	"x4x5x6", 	"y5"),
	LArc("yes",	"",	"--",	 	"--"),
*/
  };
//	   
int FCriminal::x1() { return bGoToPunishmentCell; }
//	  (true - )?
int FCriminal::x2() { return pCPrison->PunishmentCell.bLamp; }
//	     ?
int FCriminal::x3() { return nQuantityOfVisitings<2; }
//	    == 1?
int FCriminal::x4() { return nSavAcntLamp==1; }
//	       ?
int FCriminal::x5() { return bSavLamp==pCPrison->PunishmentCell.bLamp; }
//	      (   -  )?
int FCriminal::x6() { return nQuantityOfVisitings>1; }
int FCriminal::x7() { return bYes; }
//	   
//	     
void FCriminal::y1() { 
	nQuantityOfVisitings++;  //	  
	bGoToPunishmentCell = false;
}	
//	     
void FCriminal::y2() { 
	if (x3()) {
		if (x2())
			pCPrison->PunishmentCell.bLamp = false;	//   
		else 
			pCPrison->PunishmentCell.bLamp = true;		//  
	}
	bSavLamp = pCPrison->PunishmentCell.bLamp;
	nSavAcntLamp=0;

}
//	   ,   
void FCriminal::y3() {  
	bSavLamp = pCPrison->PunishmentCell.bLamp;
	nSavAcntLamp=0;
}
//	  
void FCriminal::y4() { nSavAcntLamp++; }
//	  
void FCriminal::y5() {
	int n = random(nNumber);
	if (n>0) {
		FDelayCLK *pCFDelay;
		pCFDelay = new FDelayCLK(n);
		pCFDelay->FCall(this);
	}
}

