// Prison.cpp: implementation of the CPrison class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Prison.h"
#include "NetFsaPrison.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

char p[10][10]; 
CPrison::CPrison(TNetFsa *pNF)
{
	pNetFsa = pNF;
	nNumberOfCriminals = 0;
}

CPrison::~CPrison() { DeleteObjects(); }

void CPrison::Command()
{
	if (pFOverseer) pFOverseer->Command();
}

FCriminal*	CPrison::Mx(int n)
{
	FCriminal* currentCriminal=NULL; 
	FCriminal vs(n, NULL, this);
	TIIteratorCriminal iterCriminal = IArrayCriminal.begin(); 
	while (iterCriminal != IArrayCriminal.end()) {
		currentCriminal= *iterCriminal++;
		if (*currentCriminal==vs) 
			return currentCriminal;
	}
	return NULL;
}

void CPrison::CreateObjects()
{
	for (int k=0; k<=9; k++) {
		for (int j=0; j<=9; j++)
			if (k==j) 
				p[k][j] = true;
			else 
				p[k][j] = false;

	}; 

	pFOverseer = NULL;
	pFOverseer = new FOverseer(pNetFsa, this);	//	 
	pFOfficer = NULL;
	pFOfficer = new FOfficer(pNetFsa, this);	//	 
	for (int i=1; i<=nNumberOfCriminals; i++) {
		IArrayCriminal.push_back(new FCriminal(i,pNetFsa, this));//  
	}
	pNetFsa->go_task();
}

void CPrison::DeleteObjects()
{
	if (pFOverseer) delete pFOverseer;
	if (pFOfficer) delete pFOfficer;

	TIIteratorCriminal iterCriminal = IArrayCriminal.begin(); 
	while (iterCriminal != IArrayCriminal.end()) delete  *iterCriminal++;
	IArrayCriminal.erase(IArrayCriminal.begin(), IArrayCriminal.end());
}
