// FCriminal.cpp: implementation of the FCriminal class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FCriminal.h"
#include "Prison.h"
#include "LSYSLIB\FDelayCLK.h"
#include <lsyslib\lsyslib.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FCriminal::FCriminal():LFsaAppl() { }

FCriminal::FCriminal(int n, TNetFsa *pNetFsa, CPrison *pPr, LArc *pTBL)
	:LFsaAppl(pTBL)
{
	bGoToPunishmentCell = false;	//	   
	nQuantityOfVisitings = 0;		//	  
	pCPrison = pPr;
	nNumber = n;					//	  ()
	bIfPowerUp = false;

	if (pNetFsa) FLoad(pNetFsa,1);	
}

FCriminal::~FCriminal() { }

bool FCriminal::operator==(const FCriminal &var) const	
{ 
	if (nNumber==var.nNumber) return true;
	else return false;
}

int FCriminal::GetNumber() { return nNumber; }

void FCriminal::SetNumber(int n) { nNumber = n;	}

//
LArc TT_Criminal[] = {
//	    
	LArc("",	"p",	"x1",		"y1"),		//	 
	LArc("p",	"z",	"^x2^x4",	"y2y6"),	//	 ,   ,   ->  ,   
	LArc("p",	"z",	"^x2x4",	"y6"),		//	 ,   ,   ->   n 
	LArc("p",	"z",	"x2",		"y6"),		//	  ->    n 
	LArc("z",	"",	"--",		"y5"),		//	  
	LArc()

  };
//	  ?
int FCriminal::x1() { return bGoToPunishmentCell; }
//	 ? (true - )?
int FCriminal::x2() { return pCPrison->PunishmentCell.bLamp; }
//	   ?
int FCriminal::x3() { return nQuantityOfVisitings!=0; }
//	  ?
int FCriminal::x4() { return bIfPowerUp; }
//	   
//	     
void FCriminal::y1() { 
	bGoToPunishmentCell = false;
	pCPrison->PunishmentCell.bOccupy=true;	//	"" 
}	
//	   
void FCriminal::y2() { 
	pCPrison->PunishmentCell.bLamp = true;	//   
	bIfPowerUp = true;						//	,  
}
//	     (
void FCriminal::y5() {
	nQuantityOfVisitings++;					//	  
	pCPrison->PunishmentCell.bOccupy = false;//	 
}
//	  n   
void FCriminal::y6() {
	int n = random(nNumber);
	if (n>0) {
		FDelayCLK *pCFDelay;
		pCFDelay = new FDelayCLK(n);
		pCFDelay->FCall(this);
	}
}
